'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.responseHeaders = exports.responseText = exports.responseBody = undefined;

var _queryKey = require('../lib/query-key');

var getQueryState = function getQueryState(errorsState, queryConfig, queryStateKey) {
  if (queryConfig) {
    var queryKey = (0, _queryKey.getQueryKey)(queryConfig);

    return errorsState.getIn([queryKey, queryStateKey]);
  }
};

var responseBody = exports.responseBody = function responseBody(errorsState, queryConfig) {
  return getQueryState(errorsState, queryConfig, 'responseBody');
};

var responseText = exports.responseText = function responseText(errorsState, queryConfig) {
  return getQueryState(errorsState, queryConfig, 'responseText');
};

var responseHeaders = exports.responseHeaders = function responseHeaders(errorsState, queryConfig) {
  return getQueryState(errorsState, queryConfig, 'responseHeaders');
};