'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryCount = exports.lastUpdated = exports.headers = exports.status = exports.isPending = exports.isFinished = undefined;

var _queryKey = require('../lib/query-key');

var getQueryState = function getQueryState(queriesState, queryConfig, queryStateKey) {
  if (queryConfig) {
    var queryKey = (0, _queryKey.getQueryKey)(queryConfig);

    return queriesState.getIn([queryKey, queryStateKey]);
  }
};

var isFinished = exports.isFinished = function isFinished(queriesState, queryConfig) {
  return getQueryState(queriesState, queryConfig, 'isFinished');
};

var isPending = exports.isPending = function isPending(queriesState, queryConfig) {
  return getQueryState(queriesState, queryConfig, 'isPending');
};

var status = exports.status = function status(queriesState, queryConfig) {
  return getQueryState(queriesState, queryConfig, 'status');
};

var headers = exports.headers = function headers(queriesState, queryConfig) {
  return getQueryState(queriesState, queryConfig, 'headers');
};

var lastUpdated = exports.lastUpdated = function lastUpdated(queriesState, queryConfig) {
  return getQueryState(queriesState, queryConfig, 'lastUpdated');
};

var queryCount = exports.queryCount = function queryCount(queriesState, queryConfig) {
  return getQueryState(queriesState, queryConfig, 'queryCount');
};